/* c:\mks/bin\yacc -LC -P sdlgr.mks -o sdlgr.cc sdlgr.y */
#ifdef YYTRACE
#define YYDEBUG 1
#else
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#endif
#line 1 "sdlgr.y"

/* sdl2c.y                                        bielefeld, den 8.4.1994
	Projekt sdl2c
	von sven goethel
*/

# include  "sdl2c.h"

/* DEFINES DEFINITIONEN */

/* laufvariable */
int i;

/* FLAGS */
int process_started=0;
int lokale_variable=0;
int decision_main;

/* decision level */
int decision_level=0;

/* INPUT flag, if an input if then else, is allready created */
int input_flag=0;

/* priority flag */
int prio=0;

YYSTYPE yylval;  /* yy_scan sets this ..... allready extern declared */

extern YYSTYPE yylval;
#if YYDEBUG
enum YY_Types { YY_t_NoneDefined, YY_t_string
};
#endif
#if YYDEBUG
yyTypedRules yyRules[] = {
	{ "&00: %05 &00",  0},
	{ "%05: %06",  0},
	{ "%05: %05 %06",  0},
	{ "%06: %07",  0},
	{ "%06: %08",  0},
	{ "%06: %09",  0},
	{ "%06: %10",  0},
	{ "%06: &01",  0},
	{ "%11:",  0},
	{ "%11: %12",  0},
	{ "%12: %10",  0},
	{ "%12: %12 %10",  0},
	{ "%13:",  0},
	{ "%10: &39 %13 %14 %15 &24",  0},
	{ "%10: %16",  0},
	{ "%10: %17",  0},
	{ "%10: %18",  0},
	{ "%14: &32",  0},
	{ "%14: %14 &26 &32",  0},
	{ "%15:",  0},
	{ "%15: %19",  0},
	{ "%19: &32",  0},
	{ "%21:",  0},
	{ "%23:",  0},
	{ "%24:",  0},
	{ "%26:",  0},
	{ "%07: &02 &32 %20 %21 %22 %23 %11 %24 %25 &03 %26 %27 %20",  0},
	{ "%16: &02 &32 &06 &24",  0},
	{ "%28:",  0},
	{ "%29:",  0},
	{ "%30:",  0},
	{ "%31:",  0},
	{ "%08: &05 &32 %20 %28 %22 %29 %11 %30 %25 &04 %31 %32 %20",  0},
	{ "%17: &05 &32 &06 &24",  0},
	{ "%33:",  0},
	{ "%34:",  0},
	{ "%35:",  0},
	{ "%36:",  0},
	{ "%09: &41 &32 %20 %33 %22 %34 %11 %35 %25 &42 %36 %37 %20",  0},
	{ "%18: &41 &32 &06 &24",  0},
	{ "%22:",  0},
	{ "%22: %38",  0},
	{ "%38: &36 %39 %40",  0},
	{ "%40: &35",  0},
	{ "%40: %40 &35",  0},
	{ "%39:",  0},
	{ "%39: &37",  0},
	{ "%39: &38",  0},
	{ "%25: %41 %42 %43",  0},
	{ "%41:",  0},
	{ "%41: &09 %20",  0},
	{ "%42: %44",  0},
	{ "%42: %44 %45",  0},
	{ "%42: %45",  0},
	{ "%42: &01",  0},
	{ "%43:",  0},
	{ "%43: %46",  0},
	{ "%46: %47",  0},
	{ "%46: %46 %47",  0},
	{ "%48:",  0},
	{ "%49:",  0},
	{ "%51:",  0},
	{ "%47: &10 &32 %48 %20 %49 %50 %51 %52",  0},
	{ "%50: %53",  0},
	{ "%50: %50 %53",  0},
	{ "%53: %54 %55 %42",  0},
	{ "%53: %56 %42",  0},
	{ "%53: %57",  0},
	{ "%54: &12 &32 %04 %20",  0},
	{ "%04:",  1},
	{ "%04: &31 &34",  1},
	{ "%55:",  0},
	{ "%58:",  0},
	{ "%55: &08 %58 %20",  0},
	{ "%59:",  0},
	{ "%56: &08 %59 %20",  0},
	{ "%60:",  0},
	{ "%57: &13 %60 %20",  0},
	{ "%52:",  0},
	{ "%52: &11 %61 %20",  0},
	{ "%44: %62",  0},
	{ "%63:",  0},
	{ "%44: %45 %63 %64",  0},
	{ "%44: %44 %62",  0},
	{ "%62: %65 %66",  0},
	{ "%65:",  0},
	{ "%65: %67",  0},
	{ "%65: %64 %67",  0},
	{ "%64: &32 &25",  0},
	{ "%67: %68",  0},
	{ "%67: %69",  0},
	{ "%67: %70",  0},
	{ "%67: %71",  0},
	{ "%67: %72",  0},
	{ "%67: %73",  0},
	{ "%72: &07 %74",  0},
	{ "%73: &40 %74",  0},
	{ "%68: &14 %74",  0},
	{ "%74: &34",  0},
	{ "%45: %75 %20",  0},
	{ "%75: &15 &32",  0},
	{ "%75: &16 &32",  0},
	{ "%75: &17",  0},
	{ "%75: &18",  0},
	{ "%69: &19 %01 &29 &34",  0},
	{ "%69: &19 %01 &30 &34",  0},
	{ "%01: %02",  1},
	{ "%01: %01 &26 %02",  1},
	{ "%02: &32 %03",  1},
	{ "%03:",  1},
	{ "%03: &27 &33 &28",  1},
	{ "%66: %20",  0},
	{ "%70: &20",  0},
	{ "%76:",  0},
	{ "%71: &21 &34 %76 %20 %77 &23",  0},
	{ "%77: %78",  0},
	{ "%77: %78 %79",  0},
	{ "%77: %79",  0},
	{ "%78: %80",  0},
	{ "%78: %78 %80",  0},
	{ "%80: %81 &25 %42",  0},
	{ "%82:",  0},
	{ "%79: &22 %82 &25 %42",  0},
	{ "%81: &27 &33 &28",  0},
	{ "%27: %83",  0},
	{ "%32: %83",  0},
	{ "%61: %83",  0},
	{ "%37: %83",  0},
	{ "%83:",  0},
	{ "%83: %84",  0},
	{ "%84: &32",  0},
	{ "%20: &24",  0},
{ "$accept",  0},{ "error",  0}
};
yyNamedType yyTokenTypes[] = {
	{ "$end",  0,  0},
	{ "error",  256,  0},
	{ "TPROCESS",  257,  0},
	{ "TENDPROCESS",  258,  0},
	{ "TENDPROCEDURE",  259,  0},
	{ "TPROCEDURE",  260,  0},
	{ "TREFERENCED",  261,  0},
	{ "TCALL",  262,  0},
	{ "TPROVIDED",  263,  0},
	{ "TSTART",  264,  0},
	{ "TSTATE",  265,  0},
	{ "TENDSTATE",  266,  0},
	{ "TINPUT",  267,  0},
	{ "TSAVE",  268,  0},
	{ "TTASK",  269,  0},
	{ "TNEXTSTATE",  270,  0},
	{ "TJOIN",  271,  0},
	{ "TSTOP",  272,  0},
	{ "TRETURN",  273,  0},
	{ "TOUTPUT",  274,  0},
	{ "TCREATE",  275,  0},
	{ "TDECISION",  276,  0},
	{ "TELSE",  277,  0},
	{ "TENDDECISION",  278,  0},
	{ "TSEMI_COLON",  279,  0},
	{ "TCOLON",  280,  0},
	{ "TCOMMA",  281,  0},
	{ "TBRACE_OPEN",  282,  0},
	{ "TBRACE_CLOSE",  283,  0},
	{ "TTO",  284,  0},
	{ "TVIA",  285,  0},
	{ "TFROM",  286,  0},
	{ "TRULE_NAME",  287,  1},
	{ "TBRACE_SUBJECT",  288,  1},
	{ "TC_TEXT",  289,  1},
	{ "TPARAMETER_SUBJECT",  290,  1},
	{ "TFPAR",  291,  0},
	{ "TIN",  292,  0},
	{ "TIN_OUT",  293,  0},
	{ "TDCL",  294,  0},
	{ "TMACRO",  295,  0},
	{ "TMACRODEFINITION",  296,  0},
	{ "TENDMACRO",  297,  0}

};
#endif
static short yydef[] = {

	  -1,   -5,  130,  130,  130,   -9,  133,  133,  133,  129, 
	 132,  127,  127,  127,  -13,  -17,  -21,  -25,  -33,  123, 
	 -41,  -45,  -49,  119,  -53,  -57,  -61,  122,    3,  -65, 
	 -69,  121,  -73
};
static short yyex[] = {

	   0,    0,   -1,    1,  279,  131,   -1,    1,  290,  128, 
	  -1,    1,  279,  120,   -1,    1,  287,    5,   -1,  125, 
	 279,  120,   -1,  126,  258,  124,  259,  124,  297,  124, 
	  -1,    1,  281,    6,  284,    6,  285,    6,   -1,    1, 
	 279,  118,   -1,    1,  279,  118,   -1,    1,  279,  118, 
	  -1,    1,  279,  120,   -1,    1,  279,  120,   -1,    1, 
	 279,  120,   -1,    1,  279,    4,   -1,    1,  279,  120, 
	  -1,    1,  279,  118,   -1,    1
};
static short yyact[] = {

	-149,  -92,  -93, -148,  -94,  296,  294,  260,  257,  256, 
	 -91,  287,  -90,  287,  -89,  287,  -87, -206,  279,  261, 
	 -86, -206,  279,  261,  -85, -206,  279,  261, -146,  287, 
	-167,  279, -165,  279, -163,  279,  -84, -144,  287,  281, 
	  -6,  291, -145,  287, -147,  279, -168, -169,  293,  292, 
	-130,  290,  -79,  -80, -148,  -81,  296,  294,  260,  257, 
	-129,  290,  -78,  287,  -77,  287,  -76,  287,  -87,  261, 
	 -75,  264,  -86,  261,  -85,  261, -206,  279, -128,  -64, 
	 -66,  -68,  -69, -108, -107,  -70, -100,  -71,  -63,  -65, 
	 295,  287,  276,  275,  274,  273,  272,  271,  270,  269, 
	 262,  256, -132,  297, -136,  259, -140,  258,  -99,  289, 
	 -19,  287, -109,  287, -110,  287, -112,  289, -119,  280, 
	 -64,  -66,  -70, -100,  -71,  -65,  295,  276,  275,  274, 
	 269,  262,  -64,  -66,  -68,  -69, -108, -107,  -70, -100, 
	 -71,  -63,  -65,  295,  287,  276,  275,  274,  273,  272, 
	 271,  270,  269,  262,  -58,  265,  -56,  282,  -55,  -53, 
	 -54,  285,  284,  281,  -63,  287, -127,  287, -205,  287, 
	 -48,  288, -105,  289, -106,  289,  -97,  -46,  282,  277, 
	-101,  283,  -43,  288,  -25,  280,  -98,  278,  -96,  283, 
	 -26,  280, -121,  -40, -120,  268,  267,  263,  -30,  287, 
	-122,  263,  -37,  286,  -33,  266, -123,  289,   -1
};
static short yypact[] = {

	   5,   38,   41,   41,   41,   48,   56,   56,   56,   61, 
	  56,   71,   71,   71,   90,  132,  143,  155,  157,  155, 
	 169,  169,  169,  178,   90,   90,   90,  201,  195,  203, 
	  90,  205,  169,   77,   77,   77,  207,   77,   77,  199, 
	 195,  191,  189,  187,  185,  183,   77,  181,  178,   77, 
	  77,   77,  175,  173,  111,  171,   77,  167,  165,  161, 
	  77,  126,  119,  117,  117,  117,   77,  115,  113,  111, 
	 109,  107,  105,  103,   77,   75,   73,   69,   67,   65, 
	  63,   51,   45,   43,   35,   33,   31,   29,   26,   22, 
	  18,   15,   13,   11,    5
};
static short yygo[] = {

	 -60, -103, -104,   54, -102,  -36,   -1, -151, -150,    0, 
	-152, -153, -154, -155, -157, -155, -156,   94,   10,    0, 
	-137, -141, -133,    8,    7,  -11,  -88,   -2,  -83, -158, 
	-159, -160, -161, -183, -180, -124, -181, -182, -126, -162, 
	-164, -166,  -49, -193, -111, -171, -143, -139, -135,   89, 
	  88,   74,   66,   60,   56,   51,   50,   49,   46,   38, 
	  37,   35,   34,   33,   -5, -138, -142, -134,    4,    3, 
	  -9,  -14,  -73,  -72,  -74,   13,   12,  -23,  -50,   -4, 
	  -8,  -13,  -22,  -51,   -3,   -7,  -12,  -21,  -52, -131, 
	 -82,  -10,  -15, -198, -199, -178, -177,  -18,   30,   26, 
	  25,   24, -170,  -17, -172,  -16,   16,  -20, -174, -173, 
	  19,  -47,  -41,  -29,  -32, -125, -176, -175,   28,  -28, 
	 -31,  -27, -179,  -35,  -38,  -39,  -34, -186, -184,   16, 
	 -59, -185,  -62,   58,  -61, -187, -189, -188,   61, -118, 
	-117, -116, -115, -114, -113, -190, -191, -192,   64,   63, 
	 -67,  -57,  -44,  -24, -194, -195,   23, -197, -196,   23, 
	 -45,  -42, -201, -200, -202, -203,   32,   22,   21, -204,   -1
};
static short yypgo[] = {

	   0,    0,    0,  114,    5,  130,    4,  160,  161,  142, 
	 151,  141,    4,    2,    0,    0,  140,  140,  150,  150, 
	 150,  150,  105,  147,  137,  137,  137,  137,  137,  137, 
	 132,  125,  124,  123,    5,  119,  109,  112,  111,   97, 
	  91,   91,   67,   87,   86,   85,   84,   82,   81,   80, 
	  79,   77,   71,   70,   64,   32,   27,   27,   16,   26, 
	   8,    6,    6,    8,    8,    8,    8,   25,   25,   16, 
	  16,   16,   28,   10,   29,   11,   30,   12,   31,   90, 
	  90,   74,   92,   97,  107,  107,  113,  113,  117,  117, 
	 117,  120,  121,  122,  115,  103,  103,  103,  128,  134, 
	 134,  143,  144,  139,  135,  152,  152,  153,  153,  158, 
	 155,   78,   83,  126,   88,  165,  169,   48,  165,  152, 
	 134,  115,  120,  102,  102,   97,   97,   92,   90,   89, 
	  67,   28,   22,   22,    0
};
static short yyrlen[] = {

	   0,    0,    0,    0,    0,    0,    0,    3,    0,    6, 
	   0,    1,    3,    2,    3,    1,    4,    4,    1,    1, 
	   2,    2,    2,    1,    1,    1,    1,    1,    1,    1, 
	   2,    0,    0,    0,    2,    4,    8,    0,    0,    1, 
	   2,    1,    1,    0,    0,    0,    0,    0,    0,    0, 
	   0,    0,    0,    0,    0,    1,    3,    1,    5,    0, 
	   1,    1,    2,    1,    1,    1,    1,    1,    2,    1, 
	   1,    1,    1,   13,    4,   13,    4,   13,    4,    1, 
	   1,    3,    2,    2,    1,    2,    1,    2,    3,    2, 
	   1,    3,    3,    3,    3,    1,    3,    2,    2,    1, 
	   2,    2,    2,    2,    1,    2,    1,    1,    2,    3, 
	   4,    1,    1,    1,    1,    1,    1,    1,    0,    1, 
	   0,    0,    0,    1,    0,    1,    1,    0,    0,    3, 
	   0,    0,    1,    0,    2
};
#define YYS0	94
#define YYDELTA	88
#define YYNPACT	95
#define YYNDEF	33

#define YYr132	0
#define YYr133	1
#define YYr134	2
#define YYr61	3
#define YYr69	4
#define YYr81	5
#define YYr109	6
#define YYr123	7
#define YYr121	8
#define YYr114	9
#define YYr113	10
#define YYr112	11
#define YYr110	12
#define YYr108	13
#define YYr107	14
#define YYr106	15
#define YYr105	16
#define YYr104	17
#define YYr103	18
#define YYr102	19
#define YYr101	20
#define YYr100	21
#define YYr99	22
#define YYr98	23
#define YYr94	24
#define YYr93	25
#define YYr92	26
#define YYr91	27
#define YYr90	28
#define YYr89	29
#define YYr88	30
#define YYr76	31
#define YYr74	32
#define YYr72	33
#define YYr70	34
#define YYr68	35
#define YYr62	36
#define YYr60	37
#define YYr59	38
#define YYr54	39
#define YYr44	40
#define YYr43	41
#define YYr41	42
#define YYr37	43
#define YYr36	44
#define YYr35	45
#define YYr34	46
#define YYr31	47
#define YYr30	48
#define YYr29	49
#define YYr28	50
#define YYr25	51
#define YYr24	52
#define YYr23	53
#define YYr22	54
#define YYr21	55
#define YYr18	56
#define YYr17	57
#define YYr13	58
#define YYr12	59
#define YYr7	60
#define YYrACCEPT	YYr132
#define YYrERROR	YYr133
#define YYrLR2	YYr134
#if YYDEBUG
char * yysvar[] = {
	"$accept",
	"signal_list",
	"signal",
	"output_para_opt",
	"signal_origin_opt",
	"inhalt",
	"elements",
	"process",
	"procedure",
	"macro",
	"declaration",
	"declarations_opt",
	"declarations",
	"$12",
	"dcl_var",
	"dcl_type_opt",
	"process_ref",
	"procedure_ref",
	"macro_ref",
	"dcl_type",
	"simple_end",
	"$22",
	"parameter_opt",
	"$23",
	"$24",
	"process_body",
	"$25",
	"process_name_opt",
	"$28",
	"$29",
	"$30",
	"$31",
	"procedure_name_opt",
	"$34",
	"$35",
	"$36",
	"$37",
	"macro_name_opt",
	"parameter",
	"in_out_opt",
	"paras",
	"start_opt",
	"transition",
	"state_bodys_opt",
	"transition_string",
	"terminator_statement",
	"state_bodys",
	"state_body",
	"$59",
	"$60",
	"state_recur",
	"$61",
	"endstate_opt",
	"state_input_contiguous_save",
	"state_input",
	"enabling_condition_opt",
	"contiguous_signal",
	"state_save",
	"$72",
	"$74",
	"$76",
	"state_name_opt",
	"transition_string_recur",
	"$81",
	"label",
	"n_action",
	"end",
	"action",
	"task",
	"output",
	"create_request",
	"decision",
	"procedure_call",
	"macro_call",
	"c_txt_end",
	"terminator",
	"$113",
	"decision_answer_else",
	"decision_answer_recur",
	"decision_else",
	"decision_answer",
	"answer",
	"$121",
	"name_opt",
	"name",
	0
};
short yyrmap[] = {

	 132,  133,  134,   61,   69,   81,  109,  123,  121,  114, 
	 113,  112,  110,  108,  107,  106,  105,  104,  103,  102, 
	 101,  100,   99,   98,   94,   93,   92,   91,   90,   89, 
	  88,   76,   74,   72,   70,   68,   62,   60,   59,   54, 
	  44,   43,   41,   37,   36,   35,   34,   31,   30,   29, 
	  28,   25,   24,   23,   22,   21,   18,   17,   13,   12, 
	   7,    1,    2,    3,    4,    5,    6,   10,   11,   14, 
	  15,   16,   20,   26,   27,   32,   33,   38,   39,   46, 
	  47,   48,   50,   52,   57,   58,   63,   64,   65,   66, 
	  67,   73,   75,   77,   79,   80,   82,   83,   84,   86, 
	  87,   95,   96,   97,  111,  116,  117,  118,  119,  120, 
	 122,  124,  125,  126,  127,  129,  130,  131,  128,  115, 
	  85,   78,   71,   56,   55,   53,   51,   49,   45,   42, 
	  40,   19,    9,    8,    0
};
short yysmap[] = {

	  14,   28,   30,   32,   34,   39,   49,   50,   51,   53, 
	  59,   64,   68,   69,   71,   99,  100,  101,  106,  125, 
	 127,  128,  129,  161,  167,  173,  179,  180,  182,  186, 
	 189,  191,  198,  204,  196,  195,  194,  185,  184,  177, 
	 171,  166,  165,  162,  158,  156,  152,  148,  147,  146, 
	 144,  142,  135,  134,  133,  131,  130,  123,  120,  108, 
	  96,   94,   93,   86,   85,   84,   83,   82,   81,   78, 
	  76,   74,   73,   72,   70,   66,   65,   63,   57,   56, 
	  54,   48,   38,   37,   25,   23,   21,   18,   17,   16, 
	  15,    3,    2,    1,    0,  172,  157,  170,  105,   77, 
	 163,  132,  149,  107,  150,  151,   79,   80,  109,  110, 
	 111,  112,   87,   88,   89,   90,   91,   92,  116,  175, 
	 176,  188,  200,  201,  199,  164,  137,   98,   62,   52, 
	  40,  102,   55,   41,   22,  103,   60,   42,   24,  104, 
	  61,   43,   26,   35,   44,   27,   45,    7,    8,   13, 
	  19,   12,   11,   10,    9,   58,   67,    6,    5,    4, 
	  36,  155,   33,  154,   31,  153,   29,   47,   46,  126, 
	  75,  122,  124,  138,  181,  190,  197,  187,  178,  202, 
	 193,  192,  205,   97,  136,  121,  119,   95,  117,  115, 
	 114,  113,  118,  169,  160,  159,  168,  174,  183,  145, 
	 143,  203,  141,  140,  139,   20
};
int yy_parse::yyntoken = 43;
int yy_parse::yynvar = 85;
int yy_parse::yynstate = 206;
int yy_parse::yynrule = 135;
#endif



#line 2 "sdlgr.mks"
// C++ YACC parser code
// Copyright 1991 by Mortice Kern Systems Inc.  All rights reserved.
//
// If YYDEBUG is defined as 1 and yy_parse::yydebug is set to 1,
// yyparse() will print a travelogue of its actions as it reads
// and parses input.
//
// YYSYNC can be defined to cause yyparse() to attempt to always
// hold a lookahead token

const StrClass yy_parse::LeerString;

const YY_MIN_STATE_NUM = 20;    // not useful to be too small!

#if YYDEBUG
#ifdef YYTRACE
long    * yy_parse::States    = yyStates;
#endif
yyTypedRules * yy_parse::Rules    = yyRules;
yyNamedType * yy_parse::TokenTypes = yyTokenTypes;

#define YY_TRACE(fn) { done = 0; fn(); if (done) YYRETURN(-1); }
#endif

// Constructor for yy_parse: user-provided tables
yy_parse::yy_parse(SDLProg &sdl, int sz, short * states, YYSTYPE * stack)
:sdl(sdl)
{
    mustfree = 0;
    if ((size = sz) < YY_MIN_STATE_NUM
     || (stateStack = states) == (short *) 0
     || (valueStack = stack) == (YYSTYPE *) 0) {
        fprintf(stderr,"Bad state/stack given");
        exit(1);
    }
    reset = 1;        // force reset
#if YYDEBUG
    yydebug = 0;
    typeStack = new short[size+1];
    if (typeStack == (short *) 0) {
        fprintf(stderr,"Cannot allocate typeStack");
        exit(1);
    }
#endif
}
// Constructor for yy_parse: allocate tables with new
yy_parse::yy_parse(SDLProg &sdl, int sz)
:sdl(sdl)
{
    size = sz;
    reset = 1;        // force reset
    mustfree = 1;        // delete space in deconstructor
#if YYDEBUG
    yydebug = 0;
    typeStack = new short[size+1];
#endif
    stateStack = new short[size+1];
    valueStack = new YYSTYPE[size+1];

    if (stateStack == (short *) 0 || valueStack == (YYSTYPE *) 0
#if YYDEBUG
        || typeStack == (short *) 0
#endif
        ) {
        fprintf(stderr,"Not enough space for parser stacks");
        exit(1);
    }
}
// Destructor for class yy_parse
//    Free up space
yy_parse::~yy_parse()
{
    if (mustfree) {
        delete[] stateStack;        // C++ Semantic Error, corrected by Sven Goethel
        delete[] valueStack;        // C++ Semantic Error, corrected by Sven Goethel
    }
    stateStack = (short *) 0;
#if YYDEBUG
    delete[] typeStack;                // C++ Semantic Error, corrected by Sven Goethel
#endif
}

#ifdef YACC_WINDOWS

// The initial portion of the yacc parser.
// In an windows environment, it will load the desired
// resources, obtain pointers to them, and then call
// the protected member win_yyparse() to acutally begin the
// parsing. When complete, win_yyparse() will return a
// value back to our new yyparse() function, which will
// record that value temporarily, release the resources
// from global memory, and finally return the value
// back to the caller of yyparse().

int
yy_parse::yyparse(yy_scan* ps)
{
    int wReturnValue;
    HANDLE hRes_table;
    short *old_yydef;        // the following are used for saving
    short *old_yyex;        // the current pointers
    short *old_yyact;
    short *old_yypact;
    short *old_yygo;
    short *old_yypgo;
    short *old_yyrlen;

    // the following code will load the required
    // resources for a Windows based parser.

    hRes_table = LoadResource (hInst,
        FindResource (hInst, "UD_RES_yyYACC", "yyYACCTBL"));

    // return an error code if any
    // of the resources did not load

    if (hRes_table == (HANDLE)NULL)
        return (1);
    
    // the following code will lock the resources
    // into fixed memory locations for the parser
    // (also, save away the old pointer values)

    old_yydef = yydef;
    old_yyex = yyex;
    old_yyact = yyact;
    old_yypact = yypact;
    old_yygo = yygo;
    old_yypgo = yypgo;
    old_yyrlen = yyrlen;

    yydef = (short *)LockResource (hRes_table);
    yyex = (short *)(yydef + Sizeof_yydef);
    yyact = (short *)(yyex + Sizeof_yyex);
    yypact = (short *)(yyact + Sizeof_yyact);
    yygo = (short *)(yypact + Sizeof_yypact);
    yypgo = (short *)(yygo + Sizeof_yygo);
    yyrlen = (short *)(yypgo + Sizeof_yypgo);

    // call the official yyparse() function

    wReturnValue = win_yyparse (ps);

    // unlock the resources

    UnlockResource (hRes_table);

    // and now free the resource

    FreeResource (hRes_table);

    //
    // restore previous pointer values
    //

    yydef = old_yydef;
    yyex = old_yyex;
    yyact = old_yyact;
    yypact = old_yypact;
    yygo = old_yygo;
    yypgo = old_yypgo;
    yyrlen = old_yyrlen;

    return (wReturnValue);
}    // end yyparse()


// The parser proper.
//    Note that this code is reentrant; you can return a value
//    and then resume parsing by recalling yyparse().
//    Call yyreset() before yyparse() if you want a fresh start

int
yy_parse::win_yyparse(yy_scan* ps)

#else /* YACC_WINDOWS */

// The parser proper.
//    Note that this code is reentrant; you can return a value
//    and then resume parsing by recalling yyparse().
//    Call yyreset() before yyparse() if you want a fresh start
int
yy_parse::yyparse(yy_scan* ps)

#endif /* YACC_WINDOWS */

{
    short    * yyp, * yyq;        // table lookup
    int    yyj;
#if YYDEBUG
    int    yyruletype = 0;
#endif
    static char *scannercode=";<qfgopqkfgufgC_opdwxR_-.kfgguvdpqF_fgsbccijssthcd_+,956:01/01/673_`afqrbghuqrjab_opdwx`ijqfglfgqCD_ ";
    (void)scannercode;

    if ((scan = ps) == (yy_scan *) 0) {    // scanner
        fprintf(stderr,"No scanner");
        exit(1);
    }

    if (reset) {            // start new parse
        yynerrs = 0;
        yyerrflag = 0;
        yyps = stateStack;
        yypv = valueStack;
#if YYDEBUG
        yytp = typeStack;
#endif
        yystate = YYS0;
        yyclearin();
        reset = 0;
    } else            // continue saved parse
        goto yyNext;            // after action

yyStack:
    if (++yyps > &stateStack[size]) {
        scan->yyerror("Parser stack overflow");
        YYABORT;
    }
    *yyps = yystate;    /* stack current state */
    *++yypv = yyval;    /* ... and value */
#if YYDEBUG
    if (yydebug) {
        *++yytp = yyruletype;    /* ... and type */
        YY_TRACE(yyShowState)
    }
#endif

    /*
     * Look up next action in action table.
     */
yyEncore:
#ifdef YYSYNC
    if (yychar < 0) {
        if ((yychar = scan->yylex()) < 0) {
            if (yychar == -2) YYABORT;
            yychar = 0;
        }    /* endif */
        yylval = ::yylval;
#if YYDEBUG
        if (yydebug)
            yyShowRead();    // show new input token
#endif
    }
#endif
#ifdef YACC_WINDOWS
    if (yystate >= Sizeof_yypact)     /* simple state */
#else /* YACC_WINDOWS */
    if (yystate >= sizeof yypact/sizeof yypact[0])     /* simple state */
#endif /* YACC_WINDOWS */
        yyi = yystate - YYDELTA;    /* reduce in any case */
    else {
        if(*(yyp = &yyact[yypact[yystate]]) >= 0) {
            /* Look for a shift on yychar */
#ifndef YYSYNC
            if (yychar < 0) {
                if ((yychar = scan->yylex()) < 0) {
                    if (yychar == -2) YYABORT;
                    yychar = 0;
                }    /* endif */
                yylval = ::yylval;
#if YYDEBUG
                if (yydebug)
                    yyShowRead();    // show new input token
#endif
            }
#endif
            yyq = yyp;
            yyi = yychar;
            while (yyi < *yyp++)
                ;
            if (yyi == yyp[-1]) {
                yystate = ~yyq[yyq-yyp];
#if YYDEBUG
                if (yydebug) {
                    yyruletype = yyGetType(yychar);
                    YY_TRACE(yyShowShift)
                }
#endif
                yyval = yylval;        /* stack value */
                yyclearin();        /* clear token */
                if (yyerrflag)
                    yyerrflag--;    /* successful shift */
                goto yyStack;
            }
        }

        /*
          *    Fell through - take default action
          */

#ifdef YACC_WINDOWS
        if (yystate >= Sizeof_yydef)     /* simple state */
#else /* YACC_WINDOWS */
        if (yystate >= sizeof yydef /sizeof yydef[0])
#endif /* YACC_WINDOWS */
            goto yyError;
        if ((yyi = yydef[yystate]) < 0)     { /* default == reduce? */

            /* Search exception table */
            yyp = &yyex[~yyi];
#ifndef YYSYNC
            if (yychar < 0) {
                if ((yychar = scan->yylex()) < 0) {
                    if (yychar == -2) YYABORT;
                    yychar = 0;
                }    /* endif */
                yylval = ::yylval;
#if YYDEBUG
                if (yydebug)
                    yyShowRead();    // show new input token
#endif
            }
#endif
            while((yyi = *yyp) >= 0 && yyi != yychar)
                yyp += 2;
            yyi = yyp[1];
        }
    }

    yyj = yyrlen[yyi];

#if YYDEBUG
    if (yydebug) {
        npop = yyj; rule = yyi;
        YY_TRACE(yyShowReduce)
        yytp -= yyj;
    }
#endif
    yyps -= yyj;        /* pop stacks */
    yypvt = yypv;        /* save top */
    yypv -= yyj;
    yyval = yypv[1];    /* default action $ = $1 */
#if YYDEBUG
    if (yydebug)
        yyruletype = yyRules[yyrmap[yyi]].type;
#endif
    switch (yyi) {        /* perform semantic action */
        
case YYr7: {	/* elements :  error */
#line 55 "sdlgr.y"

		   scan->yyerror("elements incorrect");
	   
} break;

case YYr12: {	/* declaration :  TDCL */
#line 69 "sdlgr.y"
 
		    PRINT(".dcl start."); 
		    if(lokale_variable==0)
		      fprintf(fHeader,"SDL_TYPE"); 
		    else {
		      scan->space();
		      fprintf(scan->yyout,"SDL_TYPE"); 
		    }   
		  
} break;

case YYr13: {	/* declaration :  TDCL $12 dcl_var dcl_type_opt TSEMI_COLON */
#line 81 "sdlgr.y"
 
		    if(lokale_variable==0)
		      fprintf(fHeader,";\n"); 
		    else fprintf(scan->yyout,";\n");
		    PRINT(".dcl end."); 
		  
} break;

case YYr17: {	/* dcl_var :  TRULE_NAME */
#line 93 "sdlgr.y"
 
		    if(lokale_variable==0)
		      fprintf(fHeader," %s", yypvt[0].string); 
		    else fprintf(scan->yyout," %s", yypvt[0].string);
		  
} break;

case YYr18: {	/* dcl_var :  dcl_var TCOMMA TRULE_NAME */
#line 99 "sdlgr.y"
 
		    if(lokale_variable==0)
		      fprintf(fHeader,", %s", yypvt[0].string); 
		    else fprintf(scan->yyout,", %s", yypvt[0].string);
		  
} break;

case YYr21: {	/* dcl_type :  TRULE_NAME */
#line 111 "sdlgr.y"
 
		    if(lokale_variable==0)
		      fprintf(fHeader," /* %s */", yypvt[0].string); 
		    else fprintf(scan->yyout," /* %s */", yypvt[0].string);
		  
} break;

case YYr22: {	/* process :  TPROCESS TRULE_NAME simple_end */
#line 120 "sdlgr.y"

	    fprintf(fHeader,"void %s ( ", yypvt[-1].string);
	    scan->space();
	    fprintf(scan->yyout,"void %s ( ", yypvt[-1].string);
	  
} break;

case YYr23: {	/* process :  TPROCESS TRULE_NAME simple_end $22 parameter_opt */
#line 126 "sdlgr.y"

	    process_started=1;
	    fprintf(fHeader," ); /* PROCESS */ \n");
	    fprintf(scan->yyout," ) /* PROCESS */\n{\n\n");
	    scan->insert_level++;
	    PrintDef();
	    lokale_variable=1;
	  
} break;

case YYr24: {	/* process :  TPROCESS TRULE_NAME simple_end $22 parameter_opt $23 declarations_opt */
#line 135 "sdlgr.y"

	    lokale_variable=0;
	    input_flag=0;
	  
} break;

case YYr25: {	/* process :  TPROCESS TRULE_NAME simple_end $22 parameter_opt $23 declarations_opt $24 process_body TENDPROCESS */
#line 142 "sdlgr.y"

	     if(input_flag!=0) 
	     {
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* SWITCH(STATE) */ \n");
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* forever STATE */ \n");
	     }
	     scan->insert_level--;
	     scan->space();
	     fprintf(scan->yyout,"} /* ENDPROCESS */ \n");
	     PRINT(".process ende erkannt."); 
	   
} break;

case YYr28: {	/* procedure :  TPROCEDURE TRULE_NAME simple_end */
#line 167 "sdlgr.y"

	      fprintf(fHeader,"void %s ( ", yypvt[-1].string);
	      scan->space();
	      fprintf(scan->yyout,"void %s ( ", yypvt[-1].string);
	    
} break;

case YYr29: {	/* procedure :  TPROCEDURE TRULE_NAME simple_end $28 parameter_opt */
#line 173 "sdlgr.y"

	    process_started=1;
	    fprintf(fHeader," ); /* PROCEDURE */ \n");
	    fprintf(scan->yyout," ) /* PROCEDURE */\n{\n\n");
	    lokale_variable=1;
	    scan->insert_level++;
	    PrintDef();
	  
} break;

case YYr30: {	/* procedure :  TPROCEDURE TRULE_NAME simple_end $28 parameter_opt $29 declarations_opt */
#line 182 "sdlgr.y"

	    lokale_variable=0;
	    input_flag=0;
	  
} break;

case YYr31: {	/* procedure :  TPROCEDURE TRULE_NAME simple_end $28 parameter_opt $29 declarations_opt $30 process_body TENDPROCEDURE */
#line 188 "sdlgr.y"
 
	     if(input_flag!=0) 
	     {
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* SWITCH(STATE) */ \n");
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* forever STATE */ \n");
	     }
	     scan->insert_level--;
	     scan->space();
	     fprintf(scan->yyout,"} /* ENDPROCEDURE */ \n");
	    
} break;

case YYr34: {	/* macro :  TMACRODEFINITION TRULE_NAME simple_end */
#line 212 "sdlgr.y"

	      fprintf(fHeader,"void %s ( ", yypvt[-1].string);
	      scan->space();
	      fprintf(scan->yyout,"void %s ( ", yypvt[-1].string);
	    
} break;

case YYr35: {	/* macro :  TMACRODEFINITION TRULE_NAME simple_end $34 parameter_opt */
#line 218 "sdlgr.y"

	    process_started=1;
	    fprintf(fHeader," ); /* MACRO */ \n");
	    fprintf(scan->yyout," ) /* MACRO */\n{\n\n");
	    scan->insert_level++;
	    lokale_variable=1;
	    PrintDef();
	  
} break;

case YYr36: {	/* macro :  TMACRODEFINITION TRULE_NAME simple_end $34 parameter_opt $35 declarations_opt */
#line 227 "sdlgr.y"

	    lokale_variable=0;
	    input_flag=0;
	  
} break;

case YYr37: {	/* macro :  TMACRODEFINITION TRULE_NAME simple_end $34 parameter_opt $35 declarations_opt $36 process_body TENDMACRO */
#line 232 "sdlgr.y"
 
	     if(input_flag!=0) 
	     {
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* SWITCH(STATE) */ \n");
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* forever STATE */ \n");
	     }
	     scan->insert_level--;
	     scan->space();
	     fprintf(scan->yyout,"} /* ENDMACRO */ \n");
	    
} break;

case YYr41: {	/* parameter_opt :  parameter */
#line 255 "sdlgr.y"
 
		    fprintf(scan->yyout,"%s", YBuffer);
		    fprintf(fHeader,"%s", YBuffer);
		  
} break;

case YYr43: {	/* paras :  TPARAMETER_SUBJECT */
#line 267 "sdlgr.y"
 
		    strcpy(YBuffer,"SDL_TYPE ");
		    strcat(YBuffer, yypvt[0].string); 
		  
} break;

case YYr44: {	/* paras :  paras TPARAMETER_SUBJECT */
#line 272 "sdlgr.y"

		    strcat(YBuffer,", SDL_TYPE ");
		    strcat(YBuffer, yypvt[0].string); 
		  
} break;

case YYr54: {	/* transition :  error */
#line 298 "sdlgr.y"

		  scan->yyerror("transition incorrect");
	    
} break;

case YYr59: {	/* state_body :  TSTATE TRULE_NAME */
#line 315 "sdlgr.y"
 
	      for(i=0; yypvt[0].string[i]!=0; i++)
		yypvt[0].string[i]=toupper(yypvt[0].string[i]);
	      if(process_started)
	      {
		fprintf(scan->yyout,"__STATE_LOOP__:\n");
		scan->space();
		fprintf(scan->yyout,"for(;;) /* forever STATE */\n");
		scan->space();
		fprintf(scan->yyout,"{\n");
		scan->insert_level++;
		scan->space();
		fprintf(scan->yyout,"switch(state) /* STATE */ \n");
		scan->space();
		fprintf(scan->yyout,"{\n");
		scan->insert_level++;
		process_started=0;
	      }
	      scan->space();
	      fprintf(scan->yyout,"case %s :\n", yypvt[0].string);
	      scan->insert_level++;
	      scan->space();
	      fprintf(scan->yyout,"Wait4Signal(&sr);\n");
	      fprintf(fStates,"%s\n", yypvt[0].string);
	      input_flag=0;
	    
} break;

case YYr60: {	/* state_body :  TSTATE TRULE_NAME $59 simple_end */
#line 342 "sdlgr.y"
 PRINT(".STATE rec."); 
} break;

case YYr61: {	/* state_body :  TSTATE TRULE_NAME $59 simple_end $60 state_recur */
#line 344 "sdlgr.y"
 PRINT(".STATE recur end."); 
} break;

case YYr62: {	/* state_body :  TSTATE TRULE_NAME $59 simple_end $60 state_recur $61 endstate_opt */
#line 346 "sdlgr.y"
 
	      scan->insert_level--;
	      scan->space();
	      fprintf(scan->yyout,"} /* IF SIGNAL END */\n");
	      scan->insert_level--;
	      PRINT(".STATE END."); 
	    
} break;

case YYr68: {	/* state_input :  TINPUT TRULE_NAME signal_origin_opt simple_end */
#line 372 "sdlgr.y"
 
		      PRINT(".INPUT rec.");
		      for(i=0; yypvt[-2].string[i]!=0; i++)
			yypvt[-2].string[i]=toupper(yypvt[-2].string[i]);
		      fprintf(fSignals,"%s\n", yypvt[-2].string);
		      if(input_flag!=0)
		      {
			scan->insert_level--;
			scan->space();
			fprintf(scan->yyout,"} else ");
		      } else scan->space();
		      fprintf(scan->yyout,"if ( sr.Signal == %s && sr.OriginProcess == ", yypvt[-2].string );
		      if(strcmp(yypvt[-1].string,"")==0) fprintf(scan->yyout,"MYSELF )\n");
		      else fprintf(scan->yyout,"%s )\n", yypvt[-1].string);
		      scan->space();
		      fprintf(scan->yyout,"{\n");
		      scan->insert_level++;
		      if(prio)
		      {
			scan->space();
			fprintf(scan->yyout,"/* PRIORITY INPUT !!! */\n");
		      }
		      input_flag=1;
		      prio=0;
		      PRINT(".state input ok.");
		    
} break;

case YYr69: {	/* signal_origin_opt :  */
#line 400 "sdlgr.y"
 yyval.string=strdup(""); 
} break;

case YYr70: {	/* signal_origin_opt :  TFROM TC_TEXT */
#line 402 "sdlgr.y"
 
				    for(i=0; yypvt[0].string[i]!=0; i++)
				      yypvt[0].string[i]=toupper(yypvt[0].string[i]);
				    fprintf(fProcess,"%s\n", yypvt[0].string);
				    yyval.string=strdup(YBuffer);
				  
} break;

case YYr72: {	/* enabling_condition_opt :  TPROVIDED */
#line 413 "sdlgr.y"
 NotSupportedYet(); 
} break;

case YYr74: {	/* contiguous_signal :  TPROVIDED */
#line 419 "sdlgr.y"
 scan->insert_level++; NotSupportedYet(); 
} break;

case YYr76: {	/* state_save :  TSAVE */
#line 425 "sdlgr.y"
 scan->insert_level++; NotSupportedYet(); 
} break;

case YYr81: {	/* transition_string :  terminator_statement */
#line 441 "sdlgr.y"
 PRINT(".transition string(terminator statement found)."); 
} break;

case YYr88: {	/* label :  TRULE_NAME TCOLON */
#line 462 "sdlgr.y"
 
		     fprintf(scan->yyout,"_%s :\n", yypvt[-1].string);
		     PRINT(".label.");
		   
} break;

case YYr89: {	/* action :  task */
#line 468 "sdlgr.y"
 PRINT(".task ok."); 
} break;

case YYr90: {	/* action :  output */
#line 469 "sdlgr.y"
 PRINT(".output ok."); 
} break;

case YYr91: {	/* action :  create_request */
#line 470 "sdlgr.y"
 PRINT(".create ok."); 
} break;

case YYr92: {	/* action :  decision */
#line 471 "sdlgr.y"
 PRINT(".decision ok."); 
} break;

case YYr93: {	/* action :  procedure_call */
#line 472 "sdlgr.y"
 PRINT(".procedure call ok."); 
} break;

case YYr94: {	/* action :  macro_call */
#line 473 "sdlgr.y"
 PRINT(".macro call ok."); 
} break;

case YYr98: {	/* c_txt_end :  TC_TEXT */
#line 492 "sdlgr.y"

	       scan->space();
	       fprintf(scan->yyout,"%s ;\n", yypvt[0].string);
	     
} break;

case YYr99: {	/* terminator_statement :  terminator simple_end */
#line 501 "sdlgr.y"
 PRINT(".terminator_statement."); 
} break;

case YYr100: {	/* terminator :  TNEXTSTATE TRULE_NAME */
#line 508 "sdlgr.y"

	      scan->space();
	      for(i=0; yypvt[0].string[i]!=0; i++)
		yypvt[0].string[i]=toupper(yypvt[0].string[i]);
	      fprintf(scan->yyout,"state = %s;\n", yypvt[0].string);
	      scan->space();
	      fprintf(scan->yyout,"goto __STATE_LOOP__;\n");
	    
} break;

case YYr101: {	/* terminator :  TJOIN TRULE_NAME */
#line 517 "sdlgr.y"
 
	      scan->space();
	      fprintf(scan->yyout,"goto _%s;\n", yypvt[0].string);
	    
} break;

case YYr102: {	/* terminator :  TSTOP */
#line 521 "sdlgr.y"

	      scan->space();
	      fprintf(scan->yyout,"StopProcess();\n");
	   
} break;

case YYr103: {	/* terminator :  TRETURN */
#line 525 "sdlgr.y"

	      scan->space();
	      fprintf(scan->yyout,"return();\n");
	   
} break;

case YYr104: {	/* output :  TOUTPUT signal_list TTO TC_TEXT */
#line 534 "sdlgr.y"

	      if(prio)
	      {
		scan->space();
		fprintf(scan->yyout,"/* PRIORITY OUTPUT !!! */\n");
	      }
	      for(i=0; yypvt[0].string[i]!=0; i++)
		yypvt[0].string[i]=toupper(yypvt[0].string[i]);
	      scan->space();
	      fprintf(scan->yyout,"SendTo (%s, %s) ;\n", yypvt[0].string, yypvt[-2].string);
	      fprintf(fProcess,"%s\n", yypvt[0].string);
	      prio=0;
	    
} break;

case YYr105: {	/* output :  TOUTPUT signal_list TVIA TC_TEXT */
#line 550 "sdlgr.y"

	      if(prio)
	      {
		scan->space();
		fprintf(scan->yyout,"/* PRIORITY OUTPUT !!! */\n");
	      }
	      for(i=0; yypvt[0].string[i]!=0; i++)
		yypvt[0].string[i]=toupper(yypvt[0].string[i]);
	      scan->space();
	      fprintf(scan->yyout,"SendVia (%s, %s) ;\n", yypvt[0].string, yypvt[-2].string);
	      fprintf(fProcess,"%s\n", yypvt[0].string);
	      prio=0;
	    
} break;

case YYr106: {	/* signal_list :  signal */
#line 566 "sdlgr.y"
 yyval.string=yypvt[0].string; 
} break;

case YYr107: {	/* signal_list :  signal_list TCOMMA signal */
#line 568 "sdlgr.y"

		    sprintf(YBuffer,"%s, %s", yypvt[-2].string, yypvt[0].string);
		    yyval.string=strdup(YBuffer);
		  
} break;

case YYr108: {	/* signal :  TRULE_NAME output_para_opt */
#line 576 "sdlgr.y"

		    for(i=0; yypvt[-1].string[i]!=0; i++)
		      yypvt[-1].string[i]=toupper(yypvt[-1].string[i]);
		    sprintf(YBuffer,"%s%s", yypvt[-1].string, yypvt[0].string);
		    fprintf(fSignals,"%s\n", yypvt[-1].string);
		    yyval.string=strdup(YBuffer);
		  
} break;

case YYr109: {	/* output_para_opt :  */
#line 585 "sdlgr.y"
 yyval.string=strdup(""); 
} break;

case YYr110: {	/* output_para_opt :  TBRACE_OPEN TBRACE_SUBJECT TBRACE_CLOSE */
#line 589 "sdlgr.y"

		   for(i=0; yypvt[-1].string[i]!=0; i++)
		     yypvt[-1].string[i]=toupper(yypvt[-1].string[i]);
		   sprintf(YBuffer," ( %s )", yypvt[-1].string);
		   yyval.string=strdup(YBuffer);
		 
} break;

case YYr112: {	/* create_request :  TCREATE */
#line 602 "sdlgr.y"
 NotSupportedYet(); 
} break;

case YYr113: {	/* decision :  TDECISION TC_TEXT */
#line 608 "sdlgr.y"
 
	      decision_level++;
	      scan->space();
	      fprintf(scan->yyout,"__decision[%d] = ( %s );\n", decision_level, yypvt[0].string);
	      decision_main=1; 
	      PRINT(".DECISION QUESTION.");
	      
	      
	      scan->space();
	    
} break;

case YYr114: {	/* decision :  TDECISION TC_TEXT $113 simple_end decision_answer_else TENDDECISION */
#line 620 "sdlgr.y"

		scan->insert_level--;
		scan->space();
		fprintf(scan->yyout,"}\n");
		decision_level--;
		PRINT(".DECISION CASE END.");
	    
} break;

case YYr121: {	/* decision_else :  TELSE */
#line 650 "sdlgr.y"

			scan->insert_level--;
			scan->space();
			fprintf(scan->yyout,"} else {\n");
			scan->insert_level++;
		    
} break;

case YYr123: {	/* answer :  TBRACE_OPEN TBRACE_SUBJECT TBRACE_CLOSE */
#line 667 "sdlgr.y"

	      if(decision_main==0)
	      {
		scan->insert_level--;
		scan->space();
		fprintf(scan->yyout,"} else ");
	      } else {
		decision_main=0;        
	      }
	      fprintf(scan->yyout,"if ( __decision[%d] %s )\n", decision_level, yypvt[-1].string);
	      scan->space();
	      fprintf(scan->yyout,"{\n");
	      scan->insert_level++;
	      PRINT(".DECISION ANSWER DONE.");
	    
} break;
#line 343 "sdlgr.mks"
    case YYrACCEPT:
        YYACCEPT;
    case YYrERROR:
        goto yyError;
    }
yyNext:
    /*
     *    Look up next state in goto table.
     */

    yyp = &yygo[yypgo[yyi]];
    yyq = yyp++;
    yyi = *yyps;
    while (yyi < *yyp++)        /* busy little loop */
        ;
    yystate = ~(yyi == *--yyp? yyq[yyq-yyp]: *yyq);
#if YYDEBUG
    if (yydebug)
        YY_TRACE(yyShowGoto)
#endif
    goto yyStack;

yyerrlabel:    ;        /* come here from YYERROR    */
    yyerrflag = 1;
    if (yyi == YYrERROR) {
        yyps--, yypv--;
#if YYDEBUG
        if (yydebug) yytp--;
#endif
    }
    
yyError:
    switch (yyerrflag) {

    case 0:        /* new error */
        yynerrs++;
        yyi = yychar;
        scan->yyerror("Syntax error");
        if (yyi != yychar) {
            /* user has changed the current token */
            /* try again */
            yyerrflag++;    /* avoid loops */
            goto yyEncore;
        }

    case 1:        /* partially recovered */
    case 2:
        yyerrflag = 3;    /* need 3 valid shifts to recover */
            
        /*
         *    Pop states, looking for a
         *    shift on `error'.
         */

        for ( ; yyps > stateStack; yyps--, yypv--
#if YYDEBUG
                    , yytp--
#endif
        ) {
#ifdef YACC_WINDOWS
            if (*yyps >= Sizeof_yypact)     /* simple state */
#else /* YACC_WINDOWS */
            if (*yyps >= sizeof yypact/sizeof yypact[0])
#endif /* YACC_WINDOWS */
                continue;
            yyp = &yyact[yypact[*yyps]];
            yyq = yyp;
            do
                ;
            while (YYERRCODE < *yyp++);
            if (YYERRCODE == yyp[-1]) {
                yystate = ~yyq[yyq-yyp];
                goto yyStack;
            }
                
            /* no shift in this state */
#if YYDEBUG
            if (yydebug && yyps > stateStack+1)
                YY_TRACE(yyShowErrRecovery)
#endif
            /* pop stacks; try again */
        }
        /* no shift on error - abort */
        break;

    case 3:
        /*
         *    Erroneous token after
         *    an error - discard it.
         */

        if (yychar == 0)  /* but not EOF */
            break;
#if YYDEBUG
        if (yydebug)
            YY_TRACE(yyShowErrDiscard)
#endif
        yyclearin();
        goto yyEncore;    /* try again in same state */
    }
    YYABORT;

}
#if YYDEBUG
/*
 * Return type of token
 */
int
yy_parse::yyGetType(int tok)
{
    yyNamedType * tp;
    for (tp = &yyTokenTypes[yyntoken-1]; tp > yyTokenTypes; tp--)
        if (tp->token == tok)
            return tp->type;
    return 0;
}

    
// Print a token legibly.
char *
yy_parse::yyptok(int tok)
{
    yyNamedType * tp;
    for (tp = &yyTokenTypes[yyntoken-1]; tp > yyTokenTypes; tp--)
        if (tp->token == tok)
            return tp->name;
    return "";
}
/*
 * Read state 'num' from YYStatesFile
 */
#ifdef YYTRACE

char *
yy_parse::yygetState(int num)
{
    int    size;
    char    *cp;
    static FILE *yyStatesFile = (FILE *) 0;
    static char yyReadBuf[YYMAX_READ+1];

    if (yyStatesFile == (FILE *) 0
     && (yyStatesFile = fopen(YYStatesFile, "r")) == (FILE *) 0)
        return "yyExpandName: cannot open states file";

    if (num < yynstate - 1)
        size = (int)(States[num+1] - States[num]);
    else {
        /* length of last item is length of file - ptr(last-1) */
        if (fseek(yyStatesFile, 0L, 2) < 0)
            goto cannot_seek;
        size = (int) (ftell(yyStatesFile) - States[num]);
    }
    if (size < 0 || size > YYMAX_READ)
        return "yyExpandName: bad read size";
    if (fseek(yyStatesFile, States[num], 0) < 0) {
    cannot_seek:
        return "yyExpandName: cannot seek in states file";
    }

    (void) fread(yyReadBuf, 1, size, yyStatesFile);
    yyReadBuf[size] = '\0';
    return yyReadBuf;
}
#endif /* YYTRACE */
/*
 * Expand encoded string into printable representation
 * Used to decode yyStates and yyRules strings.
 * If the expansion of 's' fits in 'buf', return 1; otherwise, 0.
 */
int
yy_parse::yyExpandName(int num, int isrule, char * buf, int len)
{
    int    i, n, cnt, type;
    char    * endp, * cp, * s;

    if (isrule)
        s = yyRules[num].name;
    else
#ifdef YYTRACE
        s = yygetState(num);
#else
        s = "*no states*";
#endif

    for (endp = buf + len - 8; *s; s++) {
        if (buf >= endp) {        /* too large: return 0 */
        full:    (void) strcpy(buf, " ...\n");
            return 0;
        } else if (*s == '%') {        /* nonterminal */
            type = 0;
            cnt = yynvar;
            goto getN;
        } else if (*s == '&') {        /* terminal */
            type = 1;
            cnt = yyntoken;
        getN:
            if (cnt < 100)
                i = 2;
            else if (cnt < 1000)
                i = 3;
            else
                i = 4;
            for (n = 0; i-- > 0; )
                n = (n * 10) + *++s - '0';
            if (type == 0) {
                if (n >= yynvar)
                    goto too_big;
                cp = yysvar[n];
            } else if (n >= yyntoken) {
                too_big:
                cp = "<range err>";
            } else
                cp = yyTokenTypes[n].name;

            if ((i = strlen(cp)) + buf > endp)
                goto full;
            (void) strcpy(buf, cp);
            buf += i;
        } else
            *buf++ = *s;
    }
    *buf = '\0';
    return 1;
}
#ifndef YYTRACE
/*
 * Show current state of yyparse
 */
void
yy_parse::yyShowState()
{
    (void) printf("state %d (%d), char %s (%d)\n%d stateStack entries\n",
        yysmap[yystate],yystate,yyptok(yychar),yychar,
        yypv - valueStack);
}
// show results of reduction: yyi is rule number
void
yy_parse::yyShowReduce()
{
    (void) printf("Reduce by rule %d (pop#=%d)\n", yyrmap[rule], npop);
}
// show read token
void
yy_parse::yyShowRead()
{
    (void) printf("read %s (%d)\n", yyptok(yychar), yychar);
}
// show Goto
void
yy_parse::yyShowGoto()
{
    (void) printf("goto %d (%d)\n", yysmap[yystate], yystate);
}
// show Shift
void
yy_parse::yyShowShift()
{
    (void) printf("shift %d (%d)\n", yysmap[yystate], yystate);
}
// show error recovery
void
yy_parse::yyShowErrRecovery()
{
    (void) printf("Error recovery pops state %d (%d), uncovers %d (%d)\n",
        yysmap[*(yyps-1)], *(yyps-1), yysmap[yystate], yystate);
}
// show token discards in error processing
void
yy_parse::yyShowErrDiscard()
{
    (void) printf("Error recovery discards %s (%d), ",
        yyptok(yychar), yychar);
}
#endif    /* ! YYTRACE */
#endif    /* YYDEBUG */

